﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Threading;
using TempErLibrary;
using System.IO;


namespace TEMPApp1
{
	
	public partial class TEMPForm1 : Form
	{

		static System.Windows.Forms.Timer myTimer = new System.Windows.Forms.Timer();
		static int alarmCounter ;
		static bool exitFlag = false;
		static int intInterval1;
		static int intMinAfter;
		static int intInterval2;
		static String strHistory;
		static TemperClass tempc = new TemperClass();
		static TEMPForm1 form1;
		static String strBuff;//--------Parameter File buffer
		static int intHisMaxLine ;//----Max line
		static int intHisCurLine ;//----line count
		static int intAlarmSw;//----0=Alarm not yet。　1=Alarm Done. 2=Interval2を経過時間とする。
		static int intAlarmPast;//------最初のアラームからの経過時間。
		static int intStartSw;//----0:未start  1=start done.

		public TEMPForm1()
		{
			//double deg;
			int ret;

			InitializeComponent();

			//TemperClass tempc = new TemperClass();

			form1 =this;
			try
			{
				ret = tempc.TemperReader();
				if (ret == 0)
				{
					//Console.WriteLine("");
					MessageBox.Show("TEMPer USB が見つかりませんでした。"+"\r\n"+"(TEMPer USB is not found.)");
					this.Close();
					

				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
				this.Close();
				Application.Exit();
			}
			//MessageBox.Show("---Start Form");
			// Sets the timer interval to 1 seconds.
			myTimer.Tick += new EventHandler(TimerEventProcessor);
			myTimer.Enabled = false;
			myTimer.Interval = 1000;
			myTimer.Stop();
			//----Reset
			intAlarmPast = 0;//----Reset アラーム経過時間。
			intAlarmSw = 0;//----Reset Alarm Done Sw.
			//System.Threading.Thread.Sleep(2000);   //2秒実行を停止します。
		}
	// This is the method to run when the timer is raised.
		private static void TimerEventProcessor(Object myObject,
												EventArgs myEventArgs)
		{
			String strWk1;//---Time
			String strWk2;//---Time+Temp
			double deg;
			double degWkup;
			double degWklow;
			String strWkMess;
			int iL1;
			int iLen1;
			String strHeader;//----Mail Title--
			int iWk1;

			//myTimer.Stop();
			// Displays a message box asking whether to continue running the timer.
			//if (MessageBox.Show("Continue running?", "Count is: " + alarmCounter,
			//   MessageBoxButtons.YesNo) == DialogResult.Yes)
			//

			DateTime dt;
			dt= DateTime.Now;
			strWk1=dt.ToString("yyyy/MM/dd HH:mm:ss");
			form1.txtNowTime.Text=strWk1;
			deg = tempc.StartTemperatureReading();
			form1.txtNowTemp.Text = deg.ToString("00.00");
			//----Max Temperature
			if (double.TryParse(form1.txt1MaxTemp.Text, out degWkup))//---Past Max Temperature
			{
				//---数値のとき
				degWkup = double.Parse(form1.txt1MaxTemp.Text);
			}
			else { degWkup = -1000; }//----Past Maxなし
			if (deg > degWkup)
			{//-----最大温度更新した。
				form1.txt1MaxTime.Text = strWk1;//-----Set now time
				form1.txt1MaxTemp.Text= deg.ToString("00.00");
			}
			//----Min Temperature
			if (double.TryParse(form1.txt1MinTemp.Text, out degWklow))//---Past Min Temperature
			{
				//---数値のとき
				degWklow = double.Parse(form1.txt1MinTemp.Text);
			}
			else { degWklow = 1000; }//----Past Minなし
			if (deg < degWklow)
			{//-----最低温度更新した。
				form1.txt1MinTime.Text = strWk1;//-----Set now time
				form1.txt1MinTemp.Text = deg.ToString("00.00");
			}

			strWk2 = strWk1 + "   " + deg.ToString("00.00");
			strHistory = strHistory+ strWk2 + "\r\n" ;
			intHisCurLine += 1;

			if (intHisCurLine> intHisMaxLine)
			{//----先頭の１行を取る。
				iLen1 = strHistory.Length;
				iL1 = strHistory.IndexOf("\r\n");
				strHistory = strHistory.Substring(iL1+2, iLen1-iL1-2);
			}

			form1.txtTemps.Text = strHistory;
			myTimer.Enabled = true;

			alarmCounter=int.Parse(form1.txtRemain.Text);
			alarmCounter -= 1;
			form1.txtRemain.Text = alarmCounter.ToString();

			if (alarmCounter ==0) //----計測間隔時間オーバ
			{
				alarmCounter = int.Parse(form1.txtInterval1.Text);
				if (intAlarmSw == 2)
				{//------Alarmが出て
					form1.txtRemain.Text = form1.txtInterval2.Text;//----間隔２を利用
				}
				else
				{
					form1.txtRemain.Text = form1.txtInterval1.Text;//---間隔１
				}
				if (double.TryParse(form1.txtUpTemp.Text, out degWkup))
				{
					//---数値のとき
					degWkup = double.Parse(form1.txtUpTemp.Text);
				}
				else { degWkup = 1000; }//----上限なし

				if (double.TryParse(form1.txtLowTemp.Text, out degWklow))
				{
					//---数値のとき
					degWklow = double.Parse(form1.txtLowTemp.Text);
				}
				else { degWklow = -1000; }//----下限限なし
										  //-------check上限、下限温度
				if (deg > degWkup)
				{ //---上限オーバメールする。
					intAlarmSw = 1;//----set Alarm Done Sw.
					strHeader = "上限温度を超えました(Temperature Alarm)";

					strWkMess = "上限温度が「" + degWkup + " 度」のところ、現在「" + deg + " 度」になりました。" + "\r\n";
					strWkMess = strWkMess + "(As the upper limit temperature is "+degWkup+"C, but now temperature is "+deg+ "C!)" + "\r\n";
					strWkMess = strWkMess + "部屋を調べて下さい。(Please check the room.)" + "\r\n";
					strWkMess = strWkMess + form1.txtUpTempMess.Text;

					MailClass.SendMail(strHeader,form1.txtSMTPdomain.Text,
						form1.txtSMTPport.Text,
						form1.txtSMTPmail.Text,
						form1.txtSMTPpass.Text,
						strWkMess,  //----message
						form1.txtSendMail1.Text,
						form1.txtSendMail2.Text,
						form1.txtSendMail3.Text,
						form1.txtSendMail4.Text);
					//dt = DateTime.Now;
					strWk1 = dt.ToString("yyyy/MM/dd HH:mm:ss");
					form1.txtMailSendTime.Text = strWk1;//-----Send time

				}
				if (deg < degWklow)
				{  //---下限アンダーメールする。
					intAlarmSw = 1;//----set Alarm Done Sw.
					strHeader = "下限温度を超えました(Temperature Alarm)";

					strWkMess = "下限温度が「" + degWkup + " 度」のところ、現在「" + deg + " 度」になりました。" + "\r\n";
					strWkMess = strWkMess + "(As the lower limit temperature is " + degWkup + "C, but now temperature is " + deg + "C!)" + "\r\n";
					strWkMess = strWkMess + "部屋を調べて下さい。( Please check the room.)" + "\r\n";
					strWkMess = strWkMess + form1.txtLowTempMess.Text;

					MailClass.SendMail(strHeader,
						form1.txtSMTPdomain.Text,
						form1.txtSMTPport.Text,
						form1.txtSMTPmail.Text,
						form1.txtSMTPpass.Text,
						strWkMess,  //----message
						form1.txtSendMail1.Text,
						form1.txtSendMail2.Text,
						form1.txtSendMail3.Text,
						form1.txtSendMail4.Text);
					//dt = DateTime.Now;
					strWk1 = dt.ToString("yyyy/MM/dd HH:mm:ss");
					form1.txtMailSendTime.Text = strWk1;//-----Send time

				}
			}
			if (intAlarmSw == 1)
			{//----When Alarm Sw On.
				intAlarmPast += 1;//----+1 アラーム経過時間。
				if((form1.txtInterval2.Text!=null)&&(form1.txtInterval2.Text != ""))
				{//----Interval2 指定された。
					iWk1 = int.Parse(form1.txtMinAfter.Text); //---分指定----
					if (intAlarmPast > (iWk1*60))
					{//----interval2が経過
						intAlarmSw = 2;//------アラームが出てからの設定時間(min after)が経過した。
					}

				}
			}
			
		}
		
		private void onLoad(object sender, EventArgs e)
		{
			String strWk1;
			String strBufWK;

			//MessageBox.Show("---OnLoad StartForm");

			strBufWK = FileIO.FileIOR(1, "");
			strBuff = strBufWK;

			//----間隔時間１
			if (strBufWK != null)
			{
				//---時間間隔１　この間隔で温度の上下限チェックしAlarmを出す。
				this.txtInterval1.Text = FileIO.FileIOR2(strBufWK, "interval1");
				if ((this.txtInterval1.Text == null) || (this.txtInterval1.Text == ""))
				{//---ファイル指定なし
					this.txtInterval1.Text = "60";//----60秒間隔で温度の上下限チェックしAlarmを出す。
					intInterval1 = 60;
				}
				else
				{//---指定あり---ファイルから持ってくる。
					intInterval1 = int.Parse(this.txtInterval1.Text);
				}
				//---分後に時間間隔2に変更する。
				this.txtMinAfter.Text = FileIO.FileIOR2(strBufWK, "minafter");
				if ((this.txtMinAfter.Text == null) || (this.txtMinAfter.Text == ""))
				{//---ファイル指定なし
					this.txtMinAfter.Text = "3";//---Alarmが続いたらこの分後に時間間隔2でチェックする。
					intMinAfter = 300;
				}
				else
				{//---指定あり
					intMinAfter = int.Parse(this.txtInterval1.Text);
				}
				//---時間間隔2　上記の分後にこの新しい感覚でAlarmを出す。
				this.txtInterval2.Text = FileIO.FileIOR2(strBufWK, "interval2");
				if ((this.txtInterval2.Text == null) || (this.txtInterval2.Text == ""))
				{//---ファイル指定なし
					this.txtInterval2.Text = "300";//---300sec=5 minutes間隔でチェック
					intInterval1 = 600;
				}
				else
				{//---指定あり
					intInterval2 = int.Parse(this.txtInterval1.Text);
				}

				//---上限温度
				this.txtUpTemp.Text = FileIO.FileIOR2(strBufWK, "up");
				if ((this.txtUpTemp.Text == null) || (this.txtUpTemp.Text == ""))
				{//---ファイル指定なし
					this.txtUpTemp.Text = "31";//---31℃超え
				}
				//---上限温度超過メッセージ
				this.txtUpTempMess.Text = FileIO.FileIOR2(strBufWK, "upmess");
				//---下限温度
				this.txtLowTemp.Text = FileIO.FileIOR2(strBufWK, "low");
				if ((this.txtLowTemp.Text == null) || (this.txtLowTemp.Text == ""))
				{//---ファイル指定なし
					this.txtLowTemp.Text = "7";//---- 7℃未満
				}
				//---下限温度超過メッセージ
				this.txtLowTempMess.Text = FileIO.FileIOR2(strBufWK, "lowmess");
				//---Mail Domain
				this.txtSMTPdomain.Text = FileIO.FileIOR2(strBufWK, "SMTPdomain");
				//---Mail port
				this.txtSMTPport.Text = FileIO.FileIOR2(strBufWK, "SMTPport");
				if ((this.txtSMTPport.Text == null) || (this.txtSMTPport.Text == ""))
				{//---port指定なし
					this.txtSMTPport.Text = "587";//----Port番号
				}
				//---Mail user
				this.txtSMTPmail.Text = FileIO.FileIOR2(strBufWK, "SMTPuser");
				//---Mail pass
				this.txtSMTPpass.Text = FileIO.FileIOR2(strBufWK, "SMTPpass");
				//---Mail addr1
				this.txtSendMail1.Text = FileIO.FileIOR2(strBufWK, "Mailaddr1");
				//---Mail addr2
				this.txtSendMail2.Text = FileIO.FileIOR2(strBufWK, "Mailaddr2");
				//---Mail addr3
				this.txtSendMail3.Text = FileIO.FileIOR2(strBufWK, "Mailaddr3");
				//---Mail addr4
				this.txtSendMail4.Text = FileIO.FileIOR2(strBufWK, "Mailaddr4");
				//---Max Time
				this.txt1MaxTime.Text = FileIO.FileIOR2(strBufWK, "MaxTime");
				//---Max Time
				this.txt1MaxTime.Text = FileIO.FileIOR2(strBufWK, "MaxTime");
				//---Max Temp
				this.txt1MaxTemp.Text = FileIO.FileIOR2(strBufWK, "MaxTemp");
				//---Min Time
				this.txt1MinTime.Text = FileIO.FileIOR2(strBufWK, "MinTime");
				//---Min Temp
				this.txt1MinTemp.Text = FileIO.FileIOR2(strBufWK, "MinTemp");
			}

			strHistory = "";
			intHisMaxLine = 25;
			intHisCurLine = 0;
			DateTime dt = DateTime.Now;
			strWk1 = dt.ToString("yyyy/MM/dd HH:mm:ss");
			this.txtNowTime.Text = strWk1;
			
			//MessageBox.Show("--- Form Shown--");


	    }//---on load--

		private void onClick_END(object sender, EventArgs e)
		{
			myTimer.Stop();
			MessageBox.Show("終了します。(End Program.)");
			this.Close();
			//Application.Exit();

		}

		private void onStart(object sender, EventArgs e)
		{//----開始---
		 //----StrPara up/upmess/low/lowmess/interval1/interval2/minaftre/SMTPdomain/SMTPuser/SMTPpass/
		 //----Mailaddr1/Mailaddr2/Mailaddr3/Mailaddr4/

			Double deg;
			//String strErr;
			String strBufWK1;
			if (intStartSw == 1)
			{//---Already start
				return;

			}
			intStartSw = 1;

			//MessageBox.Show("---onStart");
			//-----パラメータファイルを書く。
			strBuff = FileIO.FileIOR3(strBuff, "up", this.txtUpTemp.Text);//---up
			strBuff = FileIO.FileIOR3(strBuff, "upmess", this.txtUpTempMess.Text);//---up mess
			strBuff = FileIO.FileIOR3(strBuff, "low", this.txtLowTemp.Text);//---low
			strBuff = FileIO.FileIOR3(strBuff, "lowmess", this.txtLowTempMess.Text);//---low mess
			strBuff = FileIO.FileIOR3(strBuff, "interval1", this.txtInterval1.Text);//---interval1
			strBuff = FileIO.FileIOR3(strBuff, "interval2", this.txtInterval2.Text);//---interval1
			strBuff = FileIO.FileIOR3(strBuff, "minafter", this.txtMinAfter.Text);//---min after
			strBuff = FileIO.FileIOR3(strBuff, "SMTPdomain", this.txtSMTPdomain.Text);//---domain
			strBuff = FileIO.FileIOR3(strBuff, "SMTPuser", this.txtSMTPmail.Text);//---username
			strBuff = FileIO.FileIOR3(strBuff, "SMTPpass", this.txtSMTPpass.Text);//---pass
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr1", this.txtSendMail1.Text);//---addr1
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr2", this.txtSendMail2.Text);//---addr2
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr3", this.txtSendMail3.Text);//---addr3
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr4", this.txtSendMail4.Text);//---addr4
			strBuff = FileIO.FileIOR3(strBuff, "MaxTime", this.txt1MaxTime.Text);//---Max Time
			strBuff = FileIO.FileIOR3(strBuff, "MaxTemp", this.txt1MaxTemp.Text);//---Max Temp
			strBuff = FileIO.FileIOR3(strBuff, "MinTime", this.txt1MinTime.Text);//---Min Time
			strBuff = FileIO.FileIOR3(strBuff, "MinTemp", this.txt1MinTemp.Text);//---Min Temp

			strBufWK1 = FileIO.FileIOR(2, strBuff);

			if((this.txtInterval1.Text==null)|| (this.txtInterval1.Text == ""))
			{
				MessageBox.Show("秒間隔は省略できません。(Interval sec time is necessary.)");
				return;
			}

			//myTimer.Tick += new EventHandler(TimerEventProcessor);

			DateTime dt = DateTime.Now;
			txtNowTime.Text = dt.ToString("yyyy/MM/dd HH:mm:ss");
			deg = tempc.StartTemperatureReading();//-----dummy---
												  //----Timer start
			 //myTimer.Start();
			myTimer.Enabled = true;

			this.txtRemain.Text = this.txtInterval1.Text;//----Reset 秒間隔

			// Runs the timer, and raises the event.
			/**/
			while (exitFlag == false)
			{
				// Processes all the events in the queue.
				Application.DoEvents();
			}
			/**/
		}

		private void TEMPForm1_Shown(object sender, EventArgs e)
		{
		}
		//-----------Mail Program
		private void Click_testMail(object sender, EventArgs e)
		{//------------Test Mail Button
			String strHeader;
			String strHOST;
			String strPORT;
			String strUSER;
			String strPass;
			String strMes;
			String strAddr1;
			String strAddr2;
			String strAddr3;
			String strAddr4;
			DialogResult result = MessageBox.Show("テストメールを送りますか(Do you execute to send mail)？",
 　　　　　　　　　　　　　　　　"確認",
	　　　　　　　　　      MessageBoxButtons.YesNo,
  　　　　　　　　　　      MessageBoxIcon.Exclamation,
 　　　　　　　　　　　     MessageBoxDefaultButton.Button1);
			if (result == DialogResult.Yes)
			{//-----Send Mail
				strHeader = "TEMPerからのテストメールです(This is test mail from TEMPer.)";
				strHOST = this.txtSMTPdomain.Text;
				strPORT = this.txtSMTPport.Text;
				strUSER = this.txtSMTPmail.Text;
				strPass = this.txtSMTPpass.Text;
				strMes = "これはテストメールです。" + "\r\n" + " the TEMPer test mail.";
				strAddr1 = this.txtSendMail1.Text;
				strAddr2 = this.txtSendMail2.Text;
				strAddr3 = this.txtSendMail3.Text;
				strAddr4 = this.txtSendMail4.Text;

				MailClass.SendMail(strHeader,
					strHOST,
					strPORT,
					strUSER,
					strPass,
					strMes,
					strAddr1,
					strAddr2,
					strAddr3,
					strAddr4);
			}
		}

		//-------------Stop button Clicked.
		private void onClick_Stop(object sender, EventArgs e)
		{///-------タイマーを停止stop timer----------

			intStartSw = 0;
			//myTimer.Stop();
			myTimer.Enabled = false;

		}

		private void cmdDSP_Click(object sender, EventArgs e)
		{///----pasword display button
			
			if (txtSMTPpass.PasswordChar == '*')
			{
				txtSMTPpass.PasswordChar = '\0';//------Display the password.
			}
			else
			{
				txtSMTPpass.PasswordChar = '*';//-----Hide the password.
			}
		}

		private void TEMPForm1_FormClosed(object sender, FormClosedEventArgs e)
		{
			//MessageBox.Show("---FormClosed");

			String strBufWK1;
			//-----パラメータファイルを書き戻す。
			strBuff = FileIO.FileIOR3(strBuff, "up", this.txtUpTemp.Text);//---up
			strBuff = FileIO.FileIOR3(strBuff, "upmess", this.txtUpTempMess.Text);//---up mess
			strBuff = FileIO.FileIOR3(strBuff, "low", this.txtLowTemp.Text);//---low
			strBuff = FileIO.FileIOR3(strBuff, "lowmess", this.txtLowTempMess.Text);//---low mess
			strBuff = FileIO.FileIOR3(strBuff, "interval1", this.txtInterval1.Text);//---interval1
			strBuff = FileIO.FileIOR3(strBuff, "interval2", this.txtInterval2.Text);//---interval1
			strBuff = FileIO.FileIOR3(strBuff, "minafter", this.txtMinAfter.Text);//---min after
			strBuff = FileIO.FileIOR3(strBuff, "SMTPdomain", this.txtSMTPdomain.Text);//---domain
			strBuff = FileIO.FileIOR3(strBuff, "SMTPuser", this.txtSMTPmail.Text);//---username
			strBuff = FileIO.FileIOR3(strBuff, "SMTPpass", this.txtSMTPpass.Text);//---pass
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr1", this.txtSendMail1.Text);//---addr1
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr2", this.txtSendMail2.Text);//---addr2
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr3", this.txtSendMail3.Text);//---addr3
			strBuff = FileIO.FileIOR3(strBuff, "Mailaddr4", this.txtSendMail4.Text);//---addr4
			strBuff = FileIO.FileIOR3(strBuff, "MaxTime", this.txt1MaxTime.Text);//---Max Time
			strBuff = FileIO.FileIOR3(strBuff, "MaxTemp", this.txt1MaxTemp.Text);//---Max Temp
			strBuff = FileIO.FileIOR3(strBuff, "MinTime", this.txt1MinTime.Text);//---Min Time
			strBuff = FileIO.FileIOR3(strBuff, "MinTemp", this.txt1MinTemp.Text);//---Min Temp

			strBufWK1 = FileIO.FileIOR(2, strBuff);
			//---Program End
			Environment.Exit(0);
		}

		private void label23_Click(object sender, EventArgs e)
		{

		}
	}
}
